#include <LiquidCrystal.h>
LiquidCrystal lcd(12, 11, 5, 4, 3, 2);

uint32_t jj,kk;
int jc,cc;
int jmax,jmin,kmax,kmin;
uint32_t sa[5000];
float loopgain,plllc,pllint,pllout,oldplllc;
int pint;
int np;

float aa[10],d1[10],d2[10],w0[10],w1[10],w2[10];

float phase_diff;

void setup()
{
  float a,s;
  int i;
  for(i=0; i < 5000; i++)
    {
    a =  25.0 * 2.0 * 3.14159 * (float)i/5000.0;
    s = sin(a) + 1.0;  
    sa[i] = 0 + (uint32_t)(s * 1800.0);
    }
  pwmc_setup();
  analogWrite(DAC0,0);
  analogWrite(DAC1,0);
  ADC->ADC_MR |= 0x80;  //set free running mode on ADC
  ADC->ADC_CHER = 0xc0; //enable ADC on pin A0
  Serial.begin(250000);
  jmax=kmax=0;
  jmin=kmin=4000;
  jc=0;
  np = 2;
  loopgain = 0.001;
  get_biquad(0.05);
  cc = 0;
  lcd.begin(16, 2);
}


void loop()
{
char buf[100];
float f,sm = 0.01;
long l;
l = millis();
while((millis() - l) < 250)
  ;
f = 84e6/(200.0 * (float)(8400 - pint));    
lcd.setCursor(0,0);
lcd.print(f,2);
lcd.print("   ");    
f = 10.0*(f - 50.0);
phase_diff = sm*oldplllc + (1.0 - sm)*phase_diff;
    sprintf(buf,"%d  %f  0.0\n",pint,phase_diff);
if (f < -1.0) f = -1.0;
if (f > 1.0) f = 1.0;
//  sprintf(buf,"-10  %f  10\n",f);
    Serial.print(buf);
 
}

void pwmc_setup()
{
  //Configure PWM channels 0,1 (PWML0,PWMH0,PWML1,PWMH1), (port C.2,C.3,C.4,C.5), (pins P34,P35,P36,P37)
  REG_PIOC_PDR = 0x3FC;  //B1111111100, PIO Disable Register
  REG_PIOC_ABSR = REG_PIOC_ABSR | 0x3FCu; //B1111111100, Peripheral AB Select Register

  pmc_enable_periph_clk(ID_PWM);
  REG_PWM_ENA = REG_PWM_SR | 0x000003; //PWM Enable Register | PWM Status Register (activate channels 0,1), was B11111   ie all 5 low

  REG_PWM_CMR0 = 0x10000; //Channe0 Mode Register
  REG_PWM_CMR1 = 0x10005; //Channe1 Mode Register: Dead Time Enable DTE=1, clock divider = 5, use Mclk/512
  REG_PWM_DT0 = 0x020002; //Channe0 Dead Time Register
  REG_PWM_DT1 = 0x020002; //Channe1 Dead Time Register
  REG_PWM_CPRD0 = 8400 ; //Channe0 Period Register
  REG_PWM_CPRD1 = 10000; //Channe1 Period Register 


  NVIC_DisableIRQ(PWM_IRQn); // set up interrupt
  NVIC_ClearPendingIRQ(PWM_IRQn);
  NVIC_SetPriority(PWM_IRQn, 0);
  NVIC_EnableIRQ((IRQn_Type)36); //NVIC_EnableIRQ(PWM_IRQn);
  PWM_INTERFACE->PWM_IER1 = 0x0003; //enable interrupt on channel 0
  PWM_INTERFACE->PWM_IDR1 = 0x00FF00fc; //enable interrupt on channel 0

 // enable 16 pins in port D
  REG_PIOD_PER = 0x00ff;
  REG_PIOD_OER = 0x00ff;
  REG_PIOD_OWER = 0xFFFF;
}


void do_pll()
  {
  float a,b,fj,fk,s;
  int i,j,k;
  char buf[100];
  i = jc + 150;
  if (i > 4999) i = i - 4999;
  j = sa[i];      // k = sync (in)   j = slave (out)
  k = ADC->ADC_CDR[6];   
  if(j > jmax) jmax = j+1;  // init will div 0?
  if(j < jmin) jmin = j;
  if(k > kmax) kmax = k+1;
  if(k < kmin) kmin = k;
  fj = (float)(j - (jmax-jmin)/2);
  fk = (float)(k - (kmax-kmin)/2);
  plllc = fj * fk * loopgain;


  s = plllc;
  for(i=0; i<np; ++i)
    {
    w0[i] = d1[i]*w1[i] + d2[i]*w2[i] + s;
    s = aa[i]*(w0[i] + 2.0*w1[i] + w2[i]);
    w2[i] = w1[i];
    w1[i] = w0[i];
    }
  plllc = s;

  pllint -= plllc * 0.0004 + (plllc - oldplllc)*0.090;
  pint = (int)pllint;
  oldplllc = plllc;
  }


void PWM_Handler(void) // PWM interrupt handler
{
   volatile long ir1;
   float r,s;
   ir1 = PWM_INTERFACE->PWM_ISR1; // clear interrupt flag
   if ((ir1 & 1) == 1)
    {
    //REG_PIOD_ODSR = 2;
    jc++;
    if (jc > 4999)
      {
        jc = 0;
        //REG_PWM_CPRDUPD0 = 8400 - pint;
      }
    jj = sa[jc];
    dacc_set_channel_selection(DACC_INTERFACE, 0);
    dacc_write_conversion_data(DACC_INTERFACE, jj);
    //REG_PIOD_ODSR = 0;
    }
   if ((ir1 & 2) == 2)
    {
    REG_PWM_CPRDUPD0 = 8400 - pint;
    //dacc_set_channel_selection(DACC_INTERFACE, 1);
    //dacc_write_conversion_data(DACC_INTERFACE, 1000 - pint);    // DAC channel 1 output to fun gen VCO input
    do_pll();
    }
}


void get_biquad(float fc)
  {
  float s,r;
  int i;
  float a = tan(M_PI*fc);
  float a2 = a*a;
  for(i=0; i<np; ++i)
    {
    r =  sin(3.141592926 * (2.0*i+1.0)/(4.0*np));
    s = a2 + 2.0*a*r + 1.0;
    aa[i] = a2/s;
    d1[i] = 2.0*(1-a2)/s;
    d2[i] = -(a2 - 2.0*a*r + 1.0)/s;
    }
  }




